package DAL::ptr_manipulator;

require 5;

use DAL_C_lib;
use Carp;

use strict;
use vars qw($AUTOLOAD $VERSION @ISA @EXPORT @EXPORT_OK);

require Exporter;

@ISA = qw(Exporter);

# This line must not be broken
$VERSION = do { my @r=(q$Revision: 1.6 $=~/\d+/g); sprintf "%d."."%02d"x$#r,@r }; 


sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;

    croak('Usage: new($address, $swigtype)') if (@_ < 1 || @_ > 2);

    my $p = shift;
    my $t = shift || undef;
    
    my $self = {};

    $self->{_original_pointer} = $p;
    $self->{_swig_type} = $t;

    my $np;

    $t ? $np = $p : $np = &DAL_C_lib::ptrcast($p, $t);

    $self->{_pointer} = $np; # this is what we use in practice

    bless $self, $class;

}
# This one catches any calls to non existing methods.
sub AUTOLOAD {
    my $self = shift;
    my $method = $AUTOLOAD;
    $method =~ s/.*:://;
    return if $method =~ /DESTROY/;
    confess "Unknown method ->$method()\n";
}

sub _op {
    my $self = shift;
    return $self->{_original_pointer};
}

sub _p {
    my $self = shift;
    return $self->{_pointer};
}

sub _st {
    my $self = shift;
    return $self->{_swig_type};
}

sub set {
    my $self = shift;
    my $value = shift;
    my $index = shift;
    
    if(ref($self->_op) ne "boolPtr" and ref($self->_op) ne "int8Ptr"){ 
	&DAL_C_lib::ptrset($self->_p, $value, $index);
    } else {
	$value = pack('c',$value);
	&DAL_C_lib::ptrset($self->_p, $value, $index);
    }
}

sub value {
    my $self = shift;
    my $index = shift || 0;
    my $value;

    if(ref($self->_op) ne "boolPtr" and ref($self->_op) ne "int8Ptr"){ 
	$value = &DAL_C_lib::ptrvalue($self->_p, $index);
    } else {
	$value = &DAL_C_lib::ptrvalue($self->_p, $index);
	$value = unpack('c',$value);
    }
    return $value;
}
    
1;

